unit Unit1;

interface

uses
  Windows, Messages, SysUtils,
  Variants, Classes,
  Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls,
  math;

type
  TForm1 = class(TForm)
    Button1: TButton;
    Image1: TImage;
    Label1: TLabel;
    Edit1: TEdit;
    Label2: TLabel;
    Edit2: TEdit;
    Label3: TLabel;
    Edit3: TEdit;
    Label4: TLabel;
    Edit4: TEdit;
    Label5: TLabel;
    ColorBox1: TColorBox;
    Label6: TLabel;
    ComboBox1: TComboBox;
    Label7: TLabel;
    Label8: TLabel;
    Button2: TButton;
    ColorBox2: TColorBox;
    Label9: TLabel;
    procedure Button1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure ColorBox1Select(Sender: TObject);
    procedure ComboBox1Select(Sender: TObject);
    procedure ColorBox2Select(Sender: TObject);
    procedure Button2Click(Sender: TObject);
  private
    { Private declarations }
    ZonDib  : TCanvas;
    kol,xol : integer;
  public
    { Public declarations }
    procedure linea(x1,y1,x2,y2,col : integer);
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.FormCreate(Sender: TObject);
begin
  ZonDib := Image1.Canvas;
  kol    := 0; // pluma negra
  xol    := clWhite;
  Application.Icon.LoadFromFile('bomb.ico');
end;

procedure TForm1.linea(x1,y1,x2,y2,col : integer);
var
  tt : integer;
begin
  tt := ZonDib.Pen.Color;
  ZonDib.Pen.Color := col;
  ZonDib.MoveTo(x1,y1);
  ZonDib.LineTo(x2,y2);
  ZonDib.Pen.Color := tt;
end;

procedure TForm1.Button1Click(Sender: TObject);
var
  xc,yc,R,N,kk   : integer;
  T,dT,dA        : single;
  x1,y1,x2,y2    : integer;
  m,jj           : integer;
begin
  // lectura de datos
  xc := StrToInt(Edit1.Text);
  yc := StrToInt(Edit2.Text);
  R := StrToInt(Edit3.Text);
  N := StrToInt(Edit4.Text);

  if (N<3) OR (N>20) then begin
    ShowMessage('Error de entrada, cuide limites..');
    exit;
  end;

  dT := 2*Pi/N;
  m := 6;
  dA := dT/m;

  for jj := 0 to m - 1 do begin

    T  := jj*dA;
    x1 := xc + ceil(R*cos(T));
    y1 := yc - ceil(R*sin(T));

    for kk := 0 to N-1 do begin
      T := T + dT;
      x2 := xc + ceil(R*cos(T));
      y2 := yc - ceil(R*sin(T));

      linea(x1,y1,x2,y2,kol);

      x1:= x2; y1 := y2;
    end;

  end;
  ZonDib.Ellipse(10,10,30,30);
end;

procedure TForm1.Button2Click(Sender: TObject);
var
 tt : Integer;
begin
  tt := ZonDib.Brush.Color;
  ZonDib.Brush.Color := xol;
  ZonDib.Rectangle(0,0,Image1.Width,Image1.Height);
  ZonDib.Brush.Color := tt;
end;

procedure TForm1.ColorBox1Select(Sender: TObject);
begin
  kol := ColorBox1.Selected;
end;

procedure TForm1.ColorBox2Select(Sender: TObject);
begin
  xol := ColorBox2.Selected;
end;

procedure TForm1.ComboBox1Select(Sender: TObject);
var
  anli : integer;
begin
  anli := ComboBox1.ItemIndex + 1;
  ZonDib.Pen.Width := anli;
end;

end.

